#!/usr/bin/python
# Written by D Walker August 2019

import tkinter as tk
from tkinter import *
from tkinter.ttk import *
#from tkinter import ttk
import serial
import time


port = serial.Serial("/dev/ttyAMA0", baudrate=31250, writeTimeout=0, timeout=2.0)

#defining MIDI messages for each octave
def k1_c0():
    global c2on, c2off, c2son, c2soff, d2on, d2off, d2son, d2soff, e2on, e2off, f2on, f2off, f2son, f2soff, g2on, g2off, g2son, g2soff, a3on, a3off, a3son, a3soff, b3on, b3off
    c2on=(b'\x90\x18\x3F')
    c2off=(b'\x80\x18\x3F')
    c2son=(b'\x90\x19\x3F')
    c2soff=(b'\x80\x19\x3F')
    d2on=(b'\x90\x1A\x3F')
    d2off=(b'\x80\x1A\x3F')
    d2son=(b'\x90\x1B\x3F')
    d2soff=(b'\x80\x1B\x3F')
    e2on=(b'\x90\x1C\x3F')
    e2off=(b'\x80\x1C\x3F')
    f2on=(b'\x90\x1D\x3F')
    f2off=(b'\x80\x1D\x3F')
    f2son=(b'\x90\x1E\x3F')
    f2soff=(b'\x80\x1E\x3F')
    g2on=(b'\x90\x1F\x3F')
    g2off=(b'\x80\x1F\x3F')
    g2son=(b'\x90\x20\x3F')
    g2soff=(b'\x80\x20\x3F')
    a3on=(b'\x90\x21\x3F')
    a3off=(b'\x80\x21\x3F')
    a3son=(b'\x90\x22\x3F')
    a3soff=(b'\x80\x22\x3F')
    b3on=(b'\x90\x23\x3F')
    b3off=(b'\x80\x23\x3F')

def k1_c1():
    global c2on, c2off, c2son, c2soff, d2on, d2off, d2son, d2soff, e2on, e2off, f2on, f2off, f2son, f2soff, g2on, g2off, g2son, g2soff, a3on, a3off, a3son, a3soff, b3on, b3off
    c2on=(b'\x90\x24\x3F')
    c2off=(b'\x80\x24\x3F')
    c2son=(b'\x90\x25\x3F')
    c2soff=(b'\x80\x25\x3F')
    d2on=(b'\x90\x26\x3F')
    d2off=(b'\x80\x26\x3F')
    d2son=(b'\x90\x27\x3F')
    d2soff=(b'\x80\x27\x3F')
    e2on=(b'\x90\x28\x3F')
    e2off=(b'\x80\x28\x3F')
    f2on=(b'\x90\x29\x3F')
    f2off=(b'\x80\x29\x3F')
    f2son=(b'\x90\x2A\x3F')
    f2soff=(b'\x80\x2A\x3F')
    g2on=(b'\x90\x2B\x3F')
    g2off=(b'\x80\x2B\x3F')
    g2son=(b'\x90\x2C\x3F')
    g2soff=(b'\x80\x2C\x3F')
    a3on=(b'\x90\x2D\x3F')
    a3off=(b'\x80\x2D\x3F')
    a3son=(b'\x90\x2E\x3F')
    a3soff=(b'\x80\x2E\x3F')
    b3on=(b'\x90\x2F\x3F')
    b3off=(b'\x80\x2F\x3F')

def k1_c2():
    global c2on, c2off, c2son, c2soff, d2on, d2off, d2son, d2soff, e2on, e2off, f2on, f2off, f2son, f2soff, g2on, g2off, g2son, g2soff, a3on, a3off, a3son, a3soff, b3on, b3off
    c2on=(b'\x90\x30\x3F')
    c2off=(b'\x80\x30\x3F')
    c2son=(b'\x90\x31\x3F')
    c2soff=(b'\x80\x31\x3F')
    d2on=(b'\x90\x32\x3F')
    d2off=(b'\x80\x32\x3F')
    d2son=(b'\x90\x33\x3F')
    d2soff=(b'\x80\x33\x3F')
    e2on=(b'\x90\x34\x3F')
    e2off=(b'\x80\x34\x3F')
    f2on=(b'\x90\x35\x3F')
    f2off=(b'\x80\x35\x3F')
    f2son=(b'\x90\x36\x3F')
    f2soff=(b'\x80\x36\x3F')
    g2on=(b'\x90\x37\x3F')
    g2off=(b'\x80\x37\x3F')
    g2son=(b'\x90\x38\x3F')
    g2soff=(b'\x80\x38\x3F')
    a3on=(b'\x90\x39\x3F')
    a3off=(b'\x80\x39\x3F')
    a3son=(b'\x90\x3A\x3F')
    a3soff=(b'\x80\x3A\x3F')
    b3on=(b'\x90\x3B\x3F')
    b3off=(b'\x80\x3B\x3F')

def k1_c3():
    global c2on, c2off, c2son, c2soff, d2on, d2off, d2son, d2soff, e2on, e2off, f2on, f2off, f2son, f2soff, g2on, g2off, g2son, g2soff, a3on, a3off, a3son, a3soff, b3on, b3off
    c2on=(b'\x90\x3C\x3F')
    c2off=(b'\x80\x3C\x3F')
    c2son=(b'\x90\x3D\x3F')
    c2soff=(b'\x80\x3D\x3F')
    d2on=(b'\x90\x3E\x3F')
    d2off=(b'\x80\x3E\x3F')
    d2son=(b'\x90\x3F\x3F')
    d2soff=(b'\x80\x3F\x3F')
    e2on=(b'\x90\x40\x3F')
    e2off=(b'\x80\x40\x3F')
    f2on=(b'\x90\x41\x3F')
    f2off=(b'\x80\x41\x3F')
    f2son=(b'\x90\x42\x3F')
    f2soff=(b'\x80\x42\x3F')
    g2on=(b'\x90\x43\x3F')
    g2off=(b'\x80\x43\x3F')
    g2son=(b'\x90\x44\x3F')
    g2soff=(b'\x80\x44\x3F')
    a3on=(b'\x90\x45\x3F')
    a3off=(b'\x80\x45\x3F')
    a3son=(b'\x90\x46\x3F')
    a3soff=(b'\x80\x46\x3F')
    b3on=(b'\x90\x47\x3F')
    b3off=(b'\x80\x47\x3F')

def k1_c4():
    global c2on, c2off, c2son, c2soff, d2on, d2off, d2son, d2soff, e2on, e2off, f2on, f2off, f2son, f2soff, g2on, g2off, g2son, g2soff, a3on, a3off, a3son, a3soff, b3on, b3off
    c2on=(b'\x90\x48\x3F')
    c2off=(b'\x80\x48\x3F')
    c2son=(b'\x90\x49\x3F')
    c2soff=(b'\x80\x49\x3F')
    d2on=(b'\x90\x4A\x3F')
    d2off=(b'\x80\x4A\x3F')
    d2son=(b'\x90\x4B\x3F')
    d2soff=(b'\x80\x4B\x3F')
    e2on=(b'\x90\x4C\x3F')
    e2off=(b'\x80\x4C\x3F')
    f2on=(b'\x90\x4D\x3F')
    f2off=(b'\x80\x4D\x3F')
    f2son=(b'\x90\x4E\x3F')
    f2soff=(b'\x80\x4E\x3F')
    g2on=(b'\x90\x4F\x3F')
    g2off=(b'\x80\x4F\x3F')
    g2son=(b'\x90\x50\x3F')
    g2soff=(b'\x80\x50\x3F')
    a3on=(b'\x90\x51\x3F')
    a3off=(b'\x80\x51\x3F')
    a3son=(b'\x90\x52\x3F')
    a3soff=(b'\x80\x52\x3F')
    b3on=(b'\x90\x53\x3F')
    b3off=(b'\x80\x53\x3F')

def k1_c5():
    global c2on, c2off, c2son, c2soff, d2on, d2off, d2son, d2soff, e2on, e2off, f2on, f2off, f2son, f2soff, g2on, g2off, g2son, g2soff, a3on, a3off, a3son, a3soff, b3on, b3off
    c2on=(b'\x90\x54\x3F')
    c2off=(b'\x80\x54\x3F')
    c2son=(b'\x90\x55\x3F')
    c2soff=(b'\x80\x55\x3F')
    d2on=(b'\x90\x56\x3F')
    d2off=(b'\x80\x56\x3F')
    d2son=(b'\x90\x57\x3F')
    d2soff=(b'\x80\x57\x3F')
    e2on=(b'\x90\x58\x3F')
    e2off=(b'\x80\x58\x3F')
    f2on=(b'\x90\x59\x3F')
    f2off=(b'\x80\x59\x3F')
    f2son=(b'\x90\x5A\x3F')
    f2soff=(b'\x80\x5A\x3F')
    g2on=(b'\x90\x5B\x3F')
    g2off=(b'\x80\x5B\x3F')
    g2son=(b'\x90\x5C\x3F')
    g2soff=(b'\x80\x5C\x3F')
    a3on=(b'\x90\x5D\x3F')
    a3off=(b'\x80\x5D\x3F')
    a3son=(b'\x90\x5E\x3F')
    a3soff=(b'\x80\x5E\x3F')
    b3on=(b'\x90\x5F\x3F')
    b3off=(b'\x80\x5F\x3F')


def k2_c1():
    global c3on, c3off, c3son, c3soff, d3on, d3off, d3son, d3soff, e3on, e3off, f3on, f3off, f3son, f3soff, g3on, g3off, g3son, g3soff, a4on, a4off, a4son, a4soff, b4on, b4off
    c3on=(b'\x90\x24\x3F')
    c3off=(b'\x80\x24\x3F')
    c3son=(b'\x90\x25\x3F')
    c3soff=(b'\x80\x25\x3F')
    d3on=(b'\x90\x26\x3F')
    d3off=(b'\x80\x26\x3F')
    d3son=(b'\x90\x27\x3F')
    d3soff=(b'\x80\x27\x3F')
    e3on=(b'\x90\x28\x3F')
    e3off=(b'\x80\x28\x3F')
    f3on=(b'\x90\x29\x3F')
    f3off=(b'\x80\x29\x3F')
    f3son=(b'\x90\x2A\x3F')
    f3soff=(b'\x80\x2A\x3F')
    g3on=(b'\x90\x2B\x3F')
    g3off=(b'\x80\x2B\x3F')
    g3son=(b'\x90\x2C\x3F')
    g3soff=(b'\x80\x2C\x3F')
    a4on=(b'\x90\x2D\x3F')
    a4off=(b'\x80\x2D\x3F')
    a4son=(b'\x90\x2E\x3F')
    a4soff=(b'\x80\x2E\x3F')
    b4on=(b'\x90\x2F\x3F')
    b4off=(b'\x80\x2F\x3F')

def k2_c2():
    global c3on, c3off, c3son, c3soff, d3on, d3off, d3son, d3soff, e3on, e3off, f3on, f3off, f3son, f3soff, g3on, g3off, g3son, g3soff, a4on, a4off, a4son, a4soff, b4on, b4off
    c3on=(b'\x90\x30\x3F')
    c3off=(b'\x80\x30\x3F')
    c3son=(b'\x90\x31\x3F')
    c3soff=(b'\x80\x31\x3F')
    d3on=(b'\x90\x32\x3F')
    d3off=(b'\x80\x32\x3F')
    d3son=(b'\x90\x33\x3F')
    d3soff=(b'\x80\x33\x3F')
    e3on=(b'\x90\x34\x3F')
    e3off=(b'\x80\x34\x3F')
    f3on=(b'\x90\x35\x3F')
    f3off=(b'\x80\x35\x3F')
    f3son=(b'\x90\x36\x3F')
    f3soff=(b'\x80\x36\x3F')
    g3on=(b'\x90\x37\x3F')
    g3off=(b'\x80\x37\x3F')
    g3son=(b'\x90\x38\x3F')
    g3soff=(b'\x80\x38\x3F')
    a4on=(b'\x90\x39\x3F')
    a4off=(b'\x80\x39\x3F')
    a4son=(b'\x90\x3A\x3F')
    a4soff=(b'\x80\x3A\x3F')
    b4on=(b'\x90\x3B\x3F')
    b4off=(b'\x80\x3B\x3F')

def k2_c3():
    global c3on, c3off, c3son, c3soff, d3on, d3off, d3son, d3soff, e3on, e3off, f3on, f3off, f3son, f3soff, g3on, g3off, g3son, g3soff, a4on, a4off, a4son, a4soff, b4on, b4off
    c3on=(b'\x90\x3C\x3F')
    c3off=(b'\x80\x3C\x3F')
    c3son=(b'\x90\x3D\x3F')
    c3soff=(b'\x80\x3D\x3F')
    d3on=(b'\x90\x3E\x3F')
    d3off=(b'\x80\x3E\x3F')
    d3son=(b'\x90\x3F\x3F')
    d3soff=(b'\x80\x3F\x3F')
    e3on=(b'\x90\x40\x3F')
    e3off=(b'\x80\x40\x3F')
    f3on=(b'\x90\x41\x3F')
    f3off=(b'\x80\x41\x3F')
    f3son=(b'\x90\x42\x3F')
    f3soff=(b'\x80\x42\x3F')
    g3on=(b'\x90\x43\x3F')
    g3off=(b'\x80\x43\x3F')
    g3son=(b'\x90\x44\x3F')
    g3soff=(b'\x80\x44\x3F')
    a4on=(b'\x90\x45\x3F')
    a4off=(b'\x80\x45\x3F')
    a4son=(b'\x90\x46\x3F')
    a4soff=(b'\x80\x46\x3F')
    b4on=(b'\x90\x47\x3F')
    b4off=(b'\x80\x47\x3F')
  
def k2_c4():
    global c3on, c3off, c3son, c3soff, d3on, d3off, d3son, d3soff, e3on, e3off, f3on, f3off, f3son, f3soff, g3on, g3off, g3son, g3soff, a4on, a4off, a4son, a4soff, b4on, b4off
    c3on=(b'\x90\x48\x3F')
    c3off=(b'\x80\x48\x3F')
    c3son=(b'\x90\x49\x3F')
    c3soff=(b'\x80\x49\x3F')
    d3on=(b'\x90\x4A\x3F')
    d3off=(b'\x80\x4A\x3F')
    d3son=(b'\x90\x4B\x3F')
    d3soff=(b'\x80\x4B\x3F')
    e3on=(b'\x90\x4C\x3F')
    e3off=(b'\x80\x4C\x3F')
    f3on=(b'\x90\x4D\x3F')
    f3off=(b'\x80\x4D\x3F')
    f3son=(b'\x90\x4E\x3F')
    f3soff=(b'\x80\x4E\x3F')
    g3on=(b'\x90\x4F\x3F')
    g3off=(b'\x80\x4F\x3F')
    g3son=(b'\x90\x50\x3F')
    g3soff=(b'\x80\x50\x3F')
    a4on=(b'\x90\x51\x3F')
    a4off=(b'\x80\x51\x3F')
    a4son=(b'\x90\x52\x3F')
    a4soff=(b'\x80\x52\x3F')
    b4on=(b'\x90\x53\x3F')
    b4off=(b'\x80\x53\x3F')

def k2_c5():
    global c3on, c3off, c3son, c3soff, d3on, d3off, d3son, d3soff, e3on, e3off, f3on, f3off, f3son, f3soff, g3on, g3off, g3son, g3soff, a4on, a4off, a4son, a4soff, b4on, b4off
    c3on=(b'\x90\x54\x3F')
    c3off=(b'\x80\x54\x3F')
    c3son=(b'\x90\x55\x3F')
    c3soff=(b'\x80\x55\x3F')
    d3on=(b'\x90\x56\x3F')
    d3off=(b'\x80\x56\x3F')
    d3son=(b'\x90\x57\x3F')
    d3soff=(b'\x80\x57\x3F')
    e3on=(b'\x90\x58\x3F')
    e3off=(b'\x80\x58\x3F')
    f3on=(b'\x90\x59\x3F')
    f3off=(b'\x80\x59\x3F')
    f3son=(b'\x90\x5A\x3F')
    f3soff=(b'\x80\x5A\x3F')
    g3on=(b'\x90\x5B\x3F')
    g3off=(b'\x80\x5B\x3F')
    g3son=(b'\x90\x5C\x3F')
    g3soff=(b'\x80\x5C\x3F')
    a4on=(b'\x90\x5D\x3F')
    a4off=(b'\x80\x5D\x3F')
    a4son=(b'\x90\x5E\x3F')
    a4soff=(b'\x80\x5E\x3F')
    b4on=(b'\x90\x5F\x3F')
    b4off=(b'\x80\x5F\x3F')

def k2_c6():
    global c3on, c3off, c3son, c3soff, d3on, d3off, d3son, d3soff, e3on, e3off, f3on, f3off, f3son, f3soff, g3on, g3off, g3son, g3soff, a4on, a4off, a4son, a4soff, b4on, b4off
    c3on=(b'\x90\x60\x3F')
    c3off=(b'\x80\x60\x3F')
    c3son=(b'\x90\x61\x3F')
    c3soff=(b'\x80\x61\x3F')
    d3on=(b'\x90\x62\x3F')
    d3off=(b'\x80\x62\x3F')
    d3son=(b'\x90\x63\x3F')
    d3soff=(b'\x80\x63\x3F')
    e3on=(b'\x90\x64\x3F')
    e3off=(b'\x80\x64\x3F')
    f3on=(b'\x90\x65\x3F')
    f3off=(b'\x80\x65\x3F')
    f3son=(b'\x90\x66\x3F')
    f3soff=(b'\x80\x66\x3F')
    g3on=(b'\x90\x67\x3F')
    g3off=(b'\x80\x67\x3F')
    g3son=(b'\x90\x68\x3F')
    g3soff=(b'\x80\x68\x3F')
    a4on=(b'\x90\x69\x3F')
    a4off=(b'\x80\x69\x3F')
    a4son=(b'\x90\x6A\x3F')
    a4soff=(b'\x80\x6A\x3F')
    b4on=(b'\x90\x6B\x3F')
    b4off=(b'\x80\x6B\x3F')

def k2_c7():
    global c3on, c3off, c3son, c3soff, d3on, d3off, d3son, d3soff, e3on, e3off, f3on, f3off, f3son, f3soff, g3on, g3off, g3son, g3soff, a4on, a4off, a4son, a4soff, b4on, b4off
    c3on=(b'\x90\x6C\x3F')
    c3off=(b'\x80\x6C\x3F')
    c3son=(b'\x90\x6D\x3F')
    c3soff=(b'\x80\x6D\x3F')
    d3on=(b'\x90\x6E\x3F')
    d3off=(b'\x80\x6E\x3F')
    d3son=(b'\x90\x6F\x3F')
    d3soff=(b'\x80\x6F\x3F')
    e3on=(b'\x90\x70\x3F')
    e3off=(b'\x80\x70\x3F')
    f3on=(b'\x90\x71\x3F')
    f3off=(b'\x80\x71\x3F')
    f3son=(b'\x90\x72\x3F')
    f3soff=(b'\x80\x72\x3F')
    g3on=(b'\x90\x73\x3F')
    g3off=(b'\x80\x73\x3F')
    g3son=(b'\x90\x74\x3F')
    g3soff=(b'\x80\x74\x3F')
    a4on=(b'\x90\x75\x3F')
    a4off=(b'\x80\x75\x3F')
    a4son=(b'\x90\x76\x3F')
    a4soff=(b'\x80\x76\x3F')
    b4on=(b'\x90\x77\x3F')
    b4off=(b'\x80\x77\x3F')


def k3_c2():
    global c4on, c4off, c4son, c4soff, d4on, d4off, d4son, d4soff, e4on, e4off, f4on, f4off, f4son, f4soff, g4on, g4off, g4son, g4soff, a5on, a5off, a5son, a5soff, b5on, b5off
    c4on=(b'\x90\x3C\x3F')
    c4off=(b'\x80\x3C\x3F')
    c4son=(b'\x90\x3D\x3F')
    c3soff=(b'\x80\x3D\x3F')
    d4on=(b'\x90\x3E\x3F')
    d4off=(b'\x80\x3E\x3F')
    d4son=(b'\x90\x3F\x3F')
    d4soff=(b'\x80\x3F\x3F')
    e4on=(b'\x90\x40\x3F')
    e4off=(b'\x80\x40\x3F')
    f4on=(b'\x90\x41\x3F')
    f4off=(b'\x80\x41\x3F')
    f4son=(b'\x90\x42\x3F')
    f4soff=(b'\x80\x42\x3F')
    g4on=(b'\x90\x43\x3F')
    g4off=(b'\x80\x43\x3F')
    g4son=(b'\x90\x44\x3F')
    g4soff=(b'\x80\x44\x3F')
    a5on=(b'\x90\x45\x3F')
    a5off=(b'\x80\x45\x3F')
    a5son=(b'\x90\x46\x3F')
    a5soff=(b'\x80\x46\x3F')
    b5on=(b'\x90\x47\x3F')
    b5off=(b'\x80\x47\x3F')
 
def k3_c3():
    global c4on, c4off, c4son, c4soff, d4on, d4off, d4son, d4soff, e4on, e4off, f4on, f4off, f4son, f4soff, g4on, g4off, g4son, g4soff, a5on, a5off, a5son, a5soff, b5on, b5off
    c4on=(b'\x90\x3C\x3F')
    c4off=(b'\x80\x3C\x3F')
    c4son=(b'\x90\x3D\x3F')
    c4soff=(b'\x80\x3D\x3F')
    d4on=(b'\x90\x3E\x3F')
    d4off=(b'\x80\x3E\x3F')
    d4son=(b'\x90\x3F\x3F')
    d4soff=(b'\x80\x3F\x3F')
    e4on=(b'\x90\x40\x3F')
    e4off=(b'\x80\x40\x3F')
    f4on=(b'\x90\x41\x3F')
    f4off=(b'\x80\x41\x3F')
    f4son=(b'\x90\x42\x3F')
    f4soff=(b'\x80\x42\x3F')
    g4on=(b'\x90\x43\x3F')
    g4off=(b'\x80\x43\x3F')
    g4son=(b'\x90\x44\x3F')
    g4soff=(b'\x80\x44\x3F')
    a5on=(b'\x90\x45\x3F')
    a5off=(b'\x80\x45\x3F')
    a5son=(b'\x90\x46\x3F')
    a5soff=(b'\x80\x46\x3F')
    b5on=(b'\x90\x47\x3F')
    b5off=(b'\x80\x47\x3F')

def k3_c4():
    global c4on, c4off, c4son, c4soff, d4on, d4off, d4son, d4soff, e4on, e4off, f4on, f4off, f4son, f4soff, g4on, g4off, g4son, g4soff, a5on, a5off, a5son, a5soff, b5on, b5off
    c4on=(b'\x90\x48\x3F')
    c4off=(b'\x80\x48\x3F')
    c4son=(b'\x90\x49\x3F')
    c4soff=(b'\x80\x49\x3F')
    d4on=(b'\x90\x4A\x3F')
    d4off=(b'\x80\x4A\x3F')
    d4son=(b'\x90\x4B\x3F')
    d4soff=(b'\x80\x4B\x3F')
    e4on=(b'\x90\x4C\x3F')
    e4off=(b'\x80\x4C\x3F')
    f4on=(b'\x90\x4D\x3F')
    f4off=(b'\x80\x4D\x3F')
    f4son=(b'\x90\x4E\x3F')
    f4soff=(b'\x80\x4E\x3F')
    g4on=(b'\x90\x4F\x3F')
    g4off=(b'\x80\x4F\x3F')
    g4son=(b'\x90\x50\x3F')
    g4soff=(b'\x80\x50\x3F')
    a5on=(b'\x90\x51\x3F')
    a5off=(b'\x80\x51\x3F')
    a5son=(b'\x90\x52\x3F')
    a5soff=(b'\x80\x52\x3F')
    b5on=(b'\x90\x53\x3F')
    b5off=(b'\x80\x53\x3F')

def k3_c5():
    global c4on, c4off, c4son, c4soff, d4on, d4off, d4son, d4soff, e4on, e4off, f4on, f4off, f4son, f4soff, g4on, g4off, g4son, g4soff, a5on, a5off, a5son, a5soff, b5on, b5off
    c4on=(b'\x90\x54\x3F')
    c4off=(b'\x80\x54\x3F')
    c4son=(b'\x90\x55\x3F')
    c4soff=(b'\x80\x55\x3F')
    d4on=(b'\x90\x56\x3F')
    d4off=(b'\x80\x56\x3F')
    d4son=(b'\x90\x57\x3F')
    d4soff=(b'\x80\x57\x3F')
    e4on=(b'\x90\x58\x3F')
    e4off=(b'\x80\x58\x3F')
    f4on=(b'\x90\x59\x3F')
    f4off=(b'\x80\x59\x3F')
    f4son=(b'\x90\x5A\x3F')
    f4soff=(b'\x80\x5A\x3F')
    g4on=(b'\x90\x5B\x3F')
    g4off=(b'\x80\x5B\x3F')
    g4son=(b'\x90\x5C\x3F')
    g4soff=(b'\x80\x5C\x3F')
    a5on=(b'\x90\x5D\x3F')
    a5off=(b'\x80\x5D\x3F')
    a5son=(b'\x90\x5E\x3F')
    a5soff=(b'\x80\x5E\x3F')
    b5on=(b'\x90\x5F\x3F')
    b5off=(b'\x80\x5F\x3F')

def k3_c6():
    global c4on, c4off, c4son, c4soff, d4on, d4off, d4son, d4soff, e4on, e4off, f4on, f4off, f4son, f4soff, g4on, g4off, g4son, g4soff, a5on, a5off, a5son, a5soff, b5on, b5off
    c4on=(b'\x90\x60\x3F')
    c4off=(b'\x80\x60\x3F')
    c4son=(b'\x90\x61\x3F')
    c4soff=(b'\x80\x61\x3F')
    d4on=(b'\x90\x62\x3F')
    d4off=(b'\x80\x62\x3F')
    d4son=(b'\x90\x63\x3F')
    d4soff=(b'\x80\x63\x3F')
    e4on=(b'\x90\x64\x3F')
    e4off=(b'\x80\x64\x3F')
    f4on=(b'\x90\x65\x3F')
    f4off=(b'\x80\x65\x3F')
    f4son=(b'\x90\x66\x3F')
    f4soff=(b'\x80\x66\x3F')
    g4on=(b'\x90\x67\x3F')
    g4off=(b'\x80\x67\x3F')
    g4son=(b'\x90\x68\x3F')
    g4soff=(b'\x80\x68\x3F')
    a5on=(b'\x90\x69\x3F')
    a5off=(b'\x80\x69\x3F')
    a5son=(b'\x90\x6A\x3F')
    a5soff=(b'\x80\x6A\x3F')
    b5on=(b'\x90\x6B\x3F')
    b5off=(b'\x80\x6B\x3F')

def k3_c7():
    global c4on, c4off, c4son, c4soff, d4on, d4off, d4son, d4soff, e4on, e4off, f4on, f4off, f4son, f4soff, g4on, g4off, g4son, g4soff, a5on, a5off, a5son, a5soff, b5on, b5off
    c4on=(b'\x90\x6C\x3F')
    c4off=(b'\x80\x6C\x3F')
    c4son=(b'\x90\x6D\x3F')
    c4soff=(b'\x80\x6D\x3F')
    d4on=(b'\x90\x6E\x3F')
    d4off=(b'\x80\x6E\x3F')
    d4son=(b'\x90\x6F\x3F')
    d4soff=(b'\x80\x6F\x3F')
    e4on=(b'\x90\x70\x3F')
    e4off=(b'\x80\x70\x3F')
    f4on=(b'\x90\x71\x3F')
    f4off=(b'\x80\x71\x3F')
    f4son=(b'\x90\x72\x3F')
    f4soff=(b'\x80\x72\x3F')
    g4on=(b'\x90\x73\x3F')
    g4off=(b'\x80\x73\x3F')
    g4son=(b'\x90\x74\x3F')
    g4soff=(b'\x80\x74\x3F')
    a5on=(b'\x90\x75\x3F')
    a5off=(b'\x80\x75\x3F')
    a5son=(b'\x90\x76\x3F')
    a5soff=(b'\x80\x76\x3F')
    b5on=(b'\x90\x77\x3F')
    b5off=(b'\x80\x77\x3F')


#Power on default keyboard octaves
k1_c2()
k2_c3()
k3_c4()


#   Send MIDI message

#1st keyboard octave
def C2_on(info):
    port.write(c2on)
    return

def C2_off(info):
    port.write(c2off)
    return

def C2S_on(info):
    port.write(c2son)
    return

def C2S_off(info):
    port.write(c2soff)

def D2_on(info):
    port.write(d2on)
    return

def D2_off(info):
    port.write(d2off)

def D2S_on(info):
    port.write(d2son)
    return

def D2S_off(info):
    port.write(d2soff)

def E2_on(info):
    port.write(e2on)
    return

def E2_off(info):
    port.write(e2off)

def F2_on(info):
    port.write(f2on)
    return

def F2_off(info):
    port.write(f2off)

def F2S_on(info):
    port.write(f2son)
    return

def F2S_off(info):
    port.write(f2soff)

def G2_on(info):
    port.write(g2on)
    return

def G2_off(info):
    port.write(g2off)

def G2S_on(info):
    port.write(g2son)
    return

def G2S_off(info):
    port.write(g2soff)

def A3_on(info):
    port.write(a3on)
    return

def A3_off(info):
    port.write(a3off)

def A3S_on(info):
    port.write(a3son)
    return

def A3S_off(info):
    port.write(a3soff)

def B3_on(info):
    port.write(b3on)
    return

def B3_off(info):
    port.write(b3off)

#2nd key octave
def C3_on(info):
    port.write(c3on)
    return

def C3_off(info):
    port.write(c3off)
    return

def C3S_on(info):
    port.write(c3son)
    return

def C3S_off(info):
    port.write(c3soff)

def D3_on(info):
    port.write(d3on)
    return

def D3_off(info):
    port.write(d3off)

def D3S_on(info):
    port.write(d3son)
    return

def D3S_off(info):
    port.write(d3soff)

def E3_on(info):
    port.write(e3on)
    return

def E3_off(info):
    port.write(e3off)

def F3_on(info):
    port.write(f3on)
    return

def F3_off(info):
    port.write(f3off)

def F3S_on(info):
    port.write(f3son)
    return

def F3S_off(info):
    port.write(f3soff)

def G3_on(info):
    port.write(g3on)
    return

def G3_off(info):
    port.write(g3off)

def G3S_on(info):
    port.write(g3son)
    return

def G3S_off(info):
    port.write(g3soff)

def A4_on(info):
    port.write(a4on)
    return

def A4_off(info):
    port.write(a4off)

def A4S_on(info):
    port.write(a4son)
    return

def A4S_off(info):
    port.write(a4soff)

def B4_on(info):
    port.write(b4on)
    return

def B4_off(info):
    port.write(b4off)

#3rd key octave
def C4_on(info):
    port.write(c4on)
    return

def C4_off(info):
    port.write(c4off)
    return

def C4S_on(info):
    port.write(c4son)
    return

def C4S_off(info):
    port.write(c4soff)

def D4_on(info):
    port.write(d4on)
    return

def D4_off(info):
    port.write(d4off)

def D4S_on(info):
    port.write(d4son)
    return

def D4S_off(info):
    port.write(d4soff)

def E4_on(info):
    port.write(e4on)
    return

def E4_off(info):
    port.write(e4off)

def F4_on(info):
    port.write(f4on)
    return

def F4_off(info):
    port.write(f4off)

def F4S_on(info):
    port.write(f4son)
    return

def F4S_off(info):
    port.write(f4soff)

def G4_on(info):
    port.write(g4on)
    return

def G4_off(info):
    port.write(g4off)

def G4S_on(info):
    port.write(g4son)
    return

def G4S_off(info):
    port.write(g4soff)

def A5_on(info):
    port.write(a5on)
    return

def A5_off(info):
    port.write(a5off)

def A5S_on(info):
    port.write(a5son)
    return

def A5S_off(info):
    port.write(a5soff)

def B5_on(info):
    port.write(b5on)
    return

def B5_off(info):
    port.write(b5off)


def mode_1A():
    port.write(b'\xC1\x63\xC1\x00')
    return

def mode_1B():
    port.write(b'\xC1\x63\xC1\x01')
    return

def mode_2A():
    port.write(b'\xC1\x63\xC1\x02')
    return

def mode_2B():
    port.write(b'\xC1\x63\xC1\x03')
    return

def mode_4A():
    port.write(b'\xC1\x63\xC1\x04')
    return

def mode_4B():
    port.write(b'\xC1\x63\xC1\x05')
    return

def mode_6():
    port.write(b'\xC1\x63\xC1\x06')
    return

def mode_0A():
    port.write(b'\xC1\x63\xC1\x07')
    return

def mode_0B():
    port.write(b'\xC1\x63\xC1\x08')
    return

def mode_4PV():
    port.write(b'\xC1\x63\xC1\x09')
    return

def mode_4MV():
    port.write(b'\xC1\x63\xC1\x0A')
    return

def retrigger_on():
    port.write(b'\xC1\x63\xC1\x65')
    return

def retrigger_off():
    port.write(b'\xC1\x63\xC1\x64')
    return


#Setting colour and text on the octave selection buttons
def k1c0_():
    k1c0.configure(bg='blue')
    k1c1.configure(bg='gray86')
    k1c2.configure(bg='gray86')
    k1c3.configure(bg='gray86')
    k1c4.configure(bg='gray86')
    k1c5.configure(bg='gray86')
    C2_on_off.configure(text='C0')
    D2_on_off.configure(text='D0')
    E2_on_off.configure(text='E0')
    F2_on_off.configure(text='F0')
    G2_on_off.configure(text='G0')
    A3_on_off.configure(text='A1')
    B3_on_off.configure(text='B1')
    k1_c0()

def k1c1_():
    k1c0.configure(bg='gray86')
    k1c1.configure(bg='blue')
    k1c2.configure(bg='gray86')
    k1c3.configure(bg='gray86')
    k1c4.configure(bg='gray86')
    k1c5.configure(bg='gray86')
    C2_on_off.configure(text='C1')
    D2_on_off.configure(text='D1')
    E2_on_off.configure(text='E1')
    F2_on_off.configure(text='F1')
    G2_on_off.configure(text='G1')
    A3_on_off.configure(text='A2')
    B3_on_off.configure(text='B2')
    k1_c1()

def k1c2_():
    k1c0.configure(bg='gray86')
    k1c1.configure(bg='gray86')
    k1c2.configure(bg='blue')
    k1c3.configure(bg='gray86')
    k1c4.configure(bg='gray86')
    k1c5.configure(bg='gray86')
    C2_on_off.configure(text='C2')
    D2_on_off.configure(text='D2')
    E2_on_off.configure(text='E2')
    F2_on_off.configure(text='F2')
    G2_on_off.configure(text='G2')
    A3_on_off.configure(text='A3')
    B3_on_off.configure(text='B3')
    k1_c2()
    
def k1c3_():
    k1c0.configure(bg='gray86')
    k1c1.configure(bg='gray86')
    k1c2.configure(bg='gray86')
    k1c3.configure(bg='blue')
    k1c4.configure(bg='gray86')
    k1c5.configure(bg='gray86')
    C2_on_off.configure(text='C3')
    D2_on_off.configure(text='D3')
    E2_on_off.configure(text='E3')
    F2_on_off.configure(text='F3')
    G2_on_off.configure(text='G3')
    A3_on_off.configure(text='A4')
    B3_on_off.configure(text='B4')
    k1_c3()

def k1c4_():
    k1c0.configure(bg='gray86')
    k1c1.configure(bg='gray86')
    k1c2.configure(bg='gray86')
    k1c3.configure(bg='gray86')
    k1c4.configure(bg='blue')
    k1c5.configure(bg='gray86')
    C2_on_off.configure(text='C4')
    D2_on_off.configure(text='D4')
    E2_on_off.configure(text='E4')
    F2_on_off.configure(text='F4')
    G2_on_off.configure(text='G4')
    A3_on_off.configure(text='A5')
    B3_on_off.configure(text='B5')
    k1_c4()

def k1c5_():
    k1c0.configure(bg='gray86')
    k1c1.configure(bg='gray86')
    k1c2.configure(bg='gray86')
    k1c3.configure(bg='gray86')
    k1c4.configure(bg='gray86')
    k1c5.configure(bg='blue')
    C2_on_off.configure(text='C5')
    D2_on_off.configure(text='D5')
    E2_on_off.configure(text='E5')
    F2_on_off.configure(text='F5')
    G2_on_off.configure(text='G5')
    A3_on_off.configure(text='A6')
    B3_on_off.configure(text='B6')
    k1_c5()


def k2c1_():
    k2c1.configure(bg='red')
    k2c2.configure(bg='gray86')
    k2c3.configure(bg='gray86')
    k2c4.configure(bg='gray86')
    k2c5.configure(bg='gray86')
    k2c6.configure(bg='gray86')
    C3_on_off.configure(text='C1')
    D3_on_off.configure(text='D1')
    E3_on_off.configure(text='E1')
    F3_on_off.configure(text='F1')
    G3_on_off.configure(text='G1')
    A4_on_off.configure(text='A2')
    B4_on_off.configure(text='B2')
    k2_c1()

def k2c2_():
    k2c1.configure(bg='gray86')
    k2c2.configure(bg='red')
    k2c3.configure(bg='gray86')
    k2c4.configure(bg='gray86')
    k2c5.configure(bg='gray86')
    k2c6.configure(bg='gray86')
    C3_on_off.configure(text='C2')
    D3_on_off.configure(text='D2')
    E3_on_off.configure(text='E2')
    F3_on_off.configure(text='F2')
    G3_on_off.configure(text='G2')
    A4_on_off.configure(text='A3')
    B4_on_off.configure(text='B3')
    k2_c2()

def k2c3_():
    k2c1.configure(bg='gray86')
    k2c2.configure(bg='gray86')
    k2c3.configure(bg='red')
    k2c4.configure(bg='gray86')
    k2c5.configure(bg='gray86')
    k2c6.configure(bg='gray86')
    C3_on_off.configure(text='C3')
    D3_on_off.configure(text='D3')
    E3_on_off.configure(text='E3')
    F3_on_off.configure(text='F3')
    G3_on_off.configure(text='G3')
    A4_on_off.configure(text='A4')
    B4_on_off.configure(text='B4')
    k2_c3()

def k2c4_():
    k2c1.configure(bg='gray86')
    k2c2.configure(bg='gray86')
    k2c3.configure(bg='gray86')
    k2c4.configure(bg='red')
    k2c5.configure(bg='gray86')
    k2c6.configure(bg='gray86')
    C3_on_off.configure(text='C4')
    D3_on_off.configure(text='D4')
    E3_on_off.configure(text='E4')
    F3_on_off.configure(text='F4')
    G3_on_off.configure(text='G4')
    A4_on_off.configure(text='A5')
    B4_on_off.configure(text='B5')
    k2_c4()

def k2c5_():
    k2c1.configure(bg='gray86')
    k2c2.configure(bg='gray86')
    k2c3.configure(bg='gray86')
    k2c4.configure(bg='gray86')
    k2c5.configure(bg='red')
    k2c6.configure(bg='gray86')
    C3_on_off.configure(text='C5')
    D3_on_off.configure(text='D5')
    E3_on_off.configure(text='E5')
    F3_on_off.configure(text='F5')
    G3_on_off.configure(text='G5')
    A4_on_off.configure(text='A6')
    B4_on_off.configure(text='B6')
    k2_c5()

def k2c6_():
    k2c1.configure(bg='gray86')
    k2c2.configure(bg='gray86')
    k2c3.configure(bg='gray86')
    k2c4.configure(bg='gray86')
    k2c5.configure(bg='gray86')
    k2c6.configure(bg='red')
    C3_on_off.configure(text='C6')
    D3_on_off.configure(text='D6')
    E3_on_off.configure(text='E6')
    F3_on_off.configure(text='F6')
    G3_on_off.configure(text='G6')
    A4_on_off.configure(text='A7')
    B4_on_off.configure(text='B7')
    k2_c6()


def k3c2_():
    k3c2.configure(bg='yellow')
    k3c3.configure(bg='gray86')
    k3c4.configure(bg='gray86')
    k3c5.configure(bg='gray86')
    k3c6.configure(bg='gray86')
    k3c7.configure(bg='gray86')
    C4_on_off.configure(text='C2')
    D4_on_off.configure(text='D3')
    E4_on_off.configure(text='E2')
    F4_on_off.configure(text='F2')
    G4_on_off.configure(text='G2')
    A5_on_off.configure(text='A3')
    B5_on_off.configure(text='B3')
    k3_c2()

def k3c3_():
    k3c2.configure(bg='gray86')
    k3c3.configure(bg='yellow')
    k3c4.configure(bg='gray86')
    k3c5.configure(bg='gray86')
    k3c6.configure(bg='gray86')
    k3c7.configure(bg='gray86')
    C4_on_off.configure(text='C3')
    D4_on_off.configure(text='D3')
    E4_on_off.configure(text='E3')
    F4_on_off.configure(text='F3')
    G4_on_off.configure(text='G3')
    A5_on_off.configure(text='A4')
    B5_on_off.configure(text='B4')
    k3_c3()

def k3c4_():
    k3c2.configure(bg='gray86')
    k3c3.configure(bg='gray86')
    k3c4.configure(bg='yellow')
    k3c5.configure(bg='gray86')
    k3c6.configure(bg='gray86')
    k3c7.configure(bg='gray86')
    C4_on_off.configure(text='C4')
    D4_on_off.configure(text='D4')
    E4_on_off.configure(text='E4')
    F4_on_off.configure(text='F4')
    G4_on_off.configure(text='G4')
    A5_on_off.configure(text='A5')
    B5_on_off.configure(text='B5')
    k3_c4()

def k3c5_():
    k3c2.configure(bg='gray86')
    k3c3.configure(bg='gray86')
    k3c4.configure(bg='gray86')
    k3c5.configure(bg='yellow')
    k3c6.configure(bg='gray86')
    k3c7.configure(bg='gray86')
    C4_on_off.configure(text='C5')
    D4_on_off.configure(text='D5')
    E4_on_off.configure(text='E5')
    F4_on_off.configure(text='F5')
    G4_on_off.configure(text='G5')
    A5_on_off.configure(text='A6')
    B5_on_off.configure(text='B6')
    k3_c5()

def k3c6_():
    k3c2.configure(bg='gray86')
    k3c3.configure(bg='gray86')
    k3c4.configure(bg='gray86')
    k3c5.configure(bg='gray86')
    k3c6.configure(bg='yellow')
    k3c7.configure(bg='gray86')
    C4_on_off.configure(text='C6')
    D4_on_off.configure(text='D6')
    E4_on_off.configure(text='E6')
    F4_on_off.configure(text='F6')
    G4_on_off.configure(text='G6')
    A5_on_off.configure(text='A7')
    B5_on_off.configure(text='B7') 
    k3_c6()

def k3c7_():
    k3c2.configure(bg='gray86')
    k3c3.configure(bg='gray86')
    k3c4.configure(bg='gray86')
    k3c5.configure(bg='gray86')
    k3c6.configure(bg='gray86')
    k3c7.configure(bg='yellow')
    C4_on_off.configure(text='C7')
    D4_on_off.configure(text='D7')
    E4_on_off.configure(text='E7')
    F4_on_off.configure(text='F7')
    G4_on_off.configure(text='G7')
    A5_on_off.configure(text='A8')
    B5_on_off.configure(text='B8') 
    k3_c7()

def raise_frame(frame):
    frame.tkraise()


root = Tk()
root.title("RPi MIDI CONTROLLER")
root.geometry('800x430')
root.configure(background='dark goldenrod')


#style used to set both frame background colour
s=Style()
s.configure('keyFrame.TFrame', background='dark goldenrod')

#Defining TABs
f1 = Frame(root, style='keyFrame.TFrame')
f2 = Frame(root, style='keyFrame.TFrame')
f3 = Frame(root, style='keyFrame.TFrame')

for frame in (f1, f2, f3):
    frame.grid(row=0, column=0, sticky='news')


tk.Button(f1, text='SEQU', command=lambda:raise_frame(f2), background='yellow3', width=3).grid(column=0, row=0, sticky='nw')
tk.Button(f1, text='UTILS', command=lambda:raise_frame(f3), background='DarkSlateGray2', width=3).grid(column=0, row=0, sticky='sw')

Label(f2, text='Reserved for Sequencer', background='dark goldenrod', foreground='white').grid(column=1, row=0)
tk.Button(f2, text='KEY BD', command=lambda:raise_frame(f1),background='SeaGreen3', width=3).grid(column=0, row=0, sticky='nw')
tk.Button(f2, text='UTILS', command=lambda:raise_frame(f3),background='DarkSlateGray2', width=3).grid(column=0, row=1, sticky='sw')

tk.Button(f3, text='KEY BD', command=lambda:raise_frame(f1),background='SeaGreen3', width=3).grid(column=0, row=0, sticky='nw')
tk.Button(f3, text='SEQU', command=lambda:raise_frame(f2),background='yellow3', width=3).grid(column=0, row=1, sticky='sw')


#Define frame for octave buttons
octaveFrame=Frame(f1, style='keyFrame.TFrame')
octaveFrame.grid(row=0, column=0)

#Define keyboard frame
keyFrame=Frame(f1, style='keyFrame.TFrame')
keyFrame.grid(row=6, column=0)

#Define utils frame
utilsFrame=Frame(f3, style='keyFrame.TFrame')
utilsFrame.grid(row=10, column=6)


# Defining Util buttons
mode_1a = tk.Button(utilsFrame, command=mode_1A, width=6, text="1A", background='DarkSlateGray2')
mode_1b = tk.Button(utilsFrame, command=mode_1B, width=6, text="1B", background='DarkSlateGray2')
mode_2a = tk.Button(utilsFrame, command=mode_2A, width=6, text="2A", background='DarkSlateGray2')
mode_2b = tk.Button(utilsFrame, command=mode_2B, width=6, text="2B", background='DarkSlateGray2')
mode_4a = tk.Button(utilsFrame, command=mode_4A, width=6, text="4A", background='DarkSlateGray2')
mode_4b = tk.Button(utilsFrame, command=mode_4B, width=6, text="4B", background='DarkSlateGray2')
mode_6 = tk.Button(utilsFrame, command=mode_6, width=6, text="6", background='DarkSlateGray2')
mode_0a = tk.Button(utilsFrame, command=mode_0A, width=6, text="0A", background='DarkSlateGray2')
mode_0b = tk.Button(utilsFrame, command=mode_0B, width=6, text="0B", background='DarkSlateGray2')
mode_4pv = tk.Button(utilsFrame, command=mode_4PV, width=6, text="4PV", background='DarkSlateGray2')
mode_4mv = tk.Button(utilsFrame, command=mode_4MV, width=6, text="4MV", background='DarkSlateGray2')
ret_on = tk.Button(utilsFrame, command=retrigger_on, width=6, text="Retrig On", background='DarkSlateGray2')
ret_off = tk.Button(utilsFrame, command=retrigger_off, width=6, text="Retrig Off", background='DarkSlateGray2')
spare = tk.Button(utilsFrame, width=6, text="Spare", state=DISABLED, background='DarkSlateGray2')

mode_1a.grid(column=6, row=6)
mode_1b.grid(column=10, row=6)
mode_2a.grid(column=14, row=6)
mode_2b.grid(column=18, row=6)
mode_4a.grid(column=22, row=6)
mode_4b.grid(column=26, row=6)
mode_6.grid(column=30, row=6)
mode_0a.grid(column=6, row=10)
mode_0b.grid(column=10, row=10)
mode_4pv.grid(column=14, row=10)
mode_4mv.grid(column=18, row=10)
ret_on.grid(column=22, row=10)
ret_off.grid(column=26, row=10)
spare.grid(column=30, row=10)


#Defining octave selection buttons
k1c0 = tk.Button(octaveFrame, command=k1c0_, text="C0", width=5, activebackground='blue')
k1c1 = tk.Button(octaveFrame, command=k1c1_, text="C1", width=5, activebackground='blue')
k1c2 = tk.Button(octaveFrame, command=k1c2_, text="C2", width=5, activebackground='blue')
k1c3 = tk.Button(octaveFrame, command=k1c3_, text="C3", width=5, activebackground='blue')
k1c4 = tk.Button(octaveFrame, command=k1c4_, text="C4", width=5, activebackground='blue')
k1c5 = tk.Button(octaveFrame, command=k1c5_, text="C5", width=5, activebackground='blue')

k2c1 = tk.Button(octaveFrame, command=k2c1_, text="C1", width=5, activebackground='red')
k2c2 = tk.Button(octaveFrame, command=k2c2_, text="C2", width=5, activebackground='red')
k2c3 = tk.Button(octaveFrame, command=k2c3_, text="C3", width=5, activebackground='red')
k2c4 = tk.Button(octaveFrame, command=k2c4_, text="C4", width=5, activebackground='red')
k2c5 = tk.Button(octaveFrame, command=k2c5_, text="C5", width=5, activebackground='red')
k2c6 = tk.Button(octaveFrame, command=k2c6_, text="C6", width=5, activebackground='red')

k3c2 = tk.Button(octaveFrame, command=k3c2_, text="C2", width=5, activebackground='yellow')
k3c3 = tk.Button(octaveFrame, command=k3c3_, text="C3", width=5, activebackground='yellow')
k3c4 = tk.Button(octaveFrame, command=k3c4_, text="C4", width=5, activebackground='yellow')
k3c5 = tk.Button(octaveFrame, command=k3c5_, text="C5", width=5, activebackground='yellow')
k3c6 = tk.Button(octaveFrame, command=k3c6_, text="C6", width=5, activebackground='yellow')
k3c7 = tk.Button(octaveFrame, command=k3c7_, text="C7", width=5, activebackground='yellow')

k1c0.grid(column=14, row=0)
k1c1.grid(column=14, row=1)
k1c2.grid(column=22, row=0)
k1c3.grid(column=22, row=1)
k1c4.grid(column=30, row=0)
k1c5.grid(column=30, row=1)

k2c1.grid(column=38, row=0)
k2c2.grid(column=38, row=1)
k2c3.grid(column=42, row=0)
k2c4.grid(column=42, row=1)
k2c5.grid(column=46, row=0)
k2c6.grid(column=46, row=1)

k3c2.grid(column=50, row=0)
k3c3.grid(column=50, row=1)
k3c4.grid(column=54, row=0)
k3c5.grid(column=54, row=1)
k3c6.grid(column=58, row=0)
k3c7.grid(column=58, row=1)

space3 = Label(octaveFrame, text=" ", background='dark goldenrod')
space3.grid(column=36, row=0, columnspan=1)
space5 = Label(octaveFrame, text=" ", background='dark goldenrod')
space5.grid(column=48, row=0, columnspan=1)

#set default keyboard button colours
k1c2.configure(bg='blue')
k2c3.configure(bg='red')
k3c4.configure(bg='yellow')

# Defining Keyboard buttons
#1st key octave
C2_on_off = tk.Button(keyFrame, text="C2", width=6, height=2, bg='white', activebackground='blue')
C2_on_off.bind('<ButtonPress-1>', C2_on)
C2_on_off.bind('<ButtonRelease-1>', C2_off)

C2S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='blue')
C2S_on_off.bind('<ButtonPress-1>', C2S_on)
C2S_on_off.bind('<ButtonRelease-1>', C2S_off)

D2_on_off = tk.Button(keyFrame, text="D2", width=6, height=2, bg='white', activebackground='blue')
D2_on_off.bind('<ButtonPress-1>', D2_on)
D2_on_off.bind('<ButtonRelease-1>', D2_off)

D2S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='blue')
D2S_on_off.bind('<ButtonPress-1>', D2S_on)
D2S_on_off.bind('<ButtonRelease-1>', D2S_off)

E2_on_off = tk.Button(keyFrame, text="E2", width=6, height=2, bg='white', activebackground='blue')
E2_on_off.bind('<ButtonPress-1>', E2_on)
E2_on_off.bind('<ButtonRelease-1>', E2_off)

F2_on_off = tk.Button(keyFrame, text="F2", width=6, height=2, bg='white', activebackground='blue')
F2_on_off.bind('<ButtonPress-1>', F2_on)
F2_on_off.bind('<ButtonRelease-1>', F2_off)

F2S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='blue')
F2S_on_off.bind('<ButtonPress-1>', F2S_on)
F2S_on_off.bind('<ButtonRelease-1>', F2S_off)

G2_on_off = tk.Button(keyFrame, text="G2", width=6, height=2, bg='white', activebackground='blue')
G2_on_off.bind('<ButtonPress-1>', G2_on)
G2_on_off.bind('<ButtonRelease-1>', G2_off)

G2S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='blue')
G2S_on_off.bind('<ButtonPress-1>', G2S_on)
G2S_on_off.bind('<ButtonRelease-1>', G2S_off)

A3_on_off = tk.Button(keyFrame, text="A3", width=6, height=2, bg='white', activebackground='blue')
A3_on_off.bind('<ButtonPress-1>', A3_on)
A3_on_off.bind('<ButtonRelease-1>', A3_off)

A3S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='blue')
A3S_on_off.bind('<ButtonPress-1>', A3S_on)
A3S_on_off.bind('<ButtonRelease-1>', A3S_off)

B3_on_off = tk.Button(keyFrame, text="B3", width=6, height=2, bg='white', activebackground='blue')
B3_on_off.bind('<ButtonPress-1>', B3_on)
B3_on_off.bind('<ButtonRelease-1>', B3_off)

#2nd key octave
C3_on_off = tk.Button(keyFrame, text="C3", width=6, height=2, bg='white', activebackground='red')
C3_on_off.bind('<ButtonPress-1>', C3_on)
C3_on_off.bind('<ButtonRelease-1>', C3_off)

C3S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='red')
C3S_on_off.bind('<ButtonPress-1>', C3S_on)
C3S_on_off.bind('<ButtonRelease-1>', C3S_off)

D3_on_off = tk.Button(keyFrame, text="D3", width=6, height=2, bg='white', activebackground='red')
D3_on_off.bind('<ButtonPress-1>', D3_on)
D3_on_off.bind('<ButtonRelease-1>', D3_off)

D3S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='red')
D3S_on_off.bind('<ButtonPress-1>', D3S_on)
D3S_on_off.bind('<ButtonRelease-1>', D3S_off)

E3_on_off = tk.Button(keyFrame, text="E3", width=6, height=2, bg='white', activebackground='red')
E3_on_off.bind('<ButtonPress-1>', E3_on)
E3_on_off.bind('<ButtonRelease-1>', E3_off)

F3_on_off = tk.Button(keyFrame, text="F3", width=6, height=2, bg='white', activebackground='red')
F3_on_off.bind('<ButtonPress-1>', F3_on)
F3_on_off.bind('<ButtonRelease-1>', F3_off)

F3S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='red')
F3S_on_off.bind('<ButtonPress-1>', F3S_on)
F3S_on_off.bind('<ButtonRelease-1>', F3S_off)

G3_on_off = tk.Button(keyFrame, text="G3", width=6, height=2, bg='white', activebackground='red')
G3_on_off.bind('<ButtonPress-1>', G3_on)
G3_on_off.bind('<ButtonRelease-1>', G3_off)

G3S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='red')
G3S_on_off.bind('<ButtonPress-1>', G3S_on)
G3S_on_off.bind('<ButtonRelease-1>', G3S_off)

A4_on_off = tk.Button(keyFrame, text="A4", width=6, height=2, bg='white', activebackground='red')
A4_on_off.bind('<ButtonPress-1>', A4_on)
A4_on_off.bind('<ButtonRelease-1>', A4_off)

A4S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='red')
A4S_on_off.bind('<ButtonPress-1>', A4S_on)
A4S_on_off.bind('<ButtonRelease-1>', A4S_off)

B4_on_off = tk.Button(keyFrame, text="B4", width=6, height=2, bg='white', activebackground='red')
B4_on_off.bind('<ButtonPress-1>', B4_on)
B4_on_off.bind('<ButtonRelease-1>', B4_off)

#3rd key octave
C4_on_off = tk.Button(keyFrame, text="C4", width=6, height=2, bg='white', activebackground='yellow')
C4_on_off.bind('<ButtonPress-1>', C4_on)
C4_on_off.bind('<ButtonRelease-1>', C4_off)

C4S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='yellow')
C4S_on_off.bind('<ButtonPress-1>', C4S_on)
C4S_on_off.bind('<ButtonRelease-1>', C4S_off)

D4_on_off = tk.Button(keyFrame, text="D4", width=6, height=2, bg='white', activebackground='yellow')
D4_on_off.bind('<ButtonPress-1>', D4_on)
D4_on_off.bind('<ButtonRelease-1>', D4_off)

D4S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='yellow')
D4S_on_off.bind('<ButtonPress-1>', D4S_on)
D4S_on_off.bind('<ButtonRelease-1>', D4S_off)

E4_on_off = tk.Button(keyFrame, text="E4", width=6, height=2, bg='white', activebackground='yellow')
E4_on_off.bind('<ButtonPress-1>', E4_on)
E4_on_off.bind('<ButtonRelease-1>', E4_off)

F4_on_off = tk.Button(keyFrame, text="F4", width=6, height=2, bg='white', activebackground='yellow')
F4_on_off.bind('<ButtonPress-1>', F4_on)
F4_on_off.bind('<ButtonRelease-1>', F4_off)

F4S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='yellow')
F4S_on_off.bind('<ButtonPress-1>', F4S_on)
F4S_on_off.bind('<ButtonRelease-1>', F4S_off)

G4_on_off = tk.Button(keyFrame, text="G4", width=6, height=2, bg='white', activebackground='yellow')
G4_on_off.bind('<ButtonPress-1>', G4_on)
G4_on_off.bind('<ButtonRelease-1>', G4_off)

G4S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='yellow')
G4S_on_off.bind('<ButtonPress-1>', G4S_on)
G4S_on_off.bind('<ButtonRelease-1>', G4S_off)

A5_on_off = tk.Button(keyFrame, text="A5", width=6, height=2, bg='white', activebackground='yellow')
A5_on_off.bind('<ButtonPress-1>', A5_on)
A5_on_off.bind('<ButtonRelease-1>', A5_off)

A5S_on_off = tk.Button(keyFrame, width=2, height=4, bg='black', activebackground='yellow')
A5S_on_off.bind('<ButtonPress-1>', A5S_on)
A5S_on_off.bind('<ButtonRelease-1>', A5S_off)

B5_on_off = tk.Button(keyFrame, text="B5", width=6, height=2, bg='white', activebackground='yellow')
B5_on_off.bind('<ButtonPress-1>', B5_on)
B5_on_off.bind('<ButtonRelease-1>', B5_off)


C2_on_off.grid(column=6, row=6, columnspan=4, rowspan=2)
C2S_on_off.grid(column=10, row=4, rowspan=3)
D2_on_off.grid(column=14, row=6, columnspan=4, rowspan=2)
D2S_on_off.grid(column=18, row=4, rowspan=3)
E2_on_off.grid(column=22, row=6, columnspan=4, rowspan=2)
F2_on_off.grid(column=26, row=6, columnspan=4, rowspan=2)
F2S_on_off.grid(column=30, row=4, rowspan=3)
G2_on_off.grid(column=34, row=6, columnspan=4, rowspan=2)
G2S_on_off.grid(column=38, row=4, rowspan=3)
A3_on_off.grid(column=42, row=6, columnspan=4, rowspan=2)
A3S_on_off.grid(column=46, row=4, rowspan=3)
B3_on_off.grid(column=50, row=6, columnspan=4, rowspan=2)

C3_on_off.grid(column=6, row=20, columnspan=4, rowspan=2)
C3S_on_off.grid(column=10, row=18, rowspan=3)
D3_on_off.grid(column=14, row=20, columnspan=4, rowspan=2)
D3S_on_off.grid(column=18, row=18, rowspan=3)
E3_on_off.grid(column=22, row=20, columnspan=4, rowspan=2)
F3_on_off.grid(column=26, row=20, columnspan=4, rowspan=2)
F3S_on_off.grid(column=30, row=18, rowspan=3)
G3_on_off.grid(column=34, row=20, columnspan=4, rowspan=2)
G3S_on_off.grid(column=38, row=18, rowspan=3)
A4_on_off.grid(column=42, row=20, columnspan=4, rowspan=2)
A4S_on_off.grid(column=46, row=18, rowspan=3)
B4_on_off.grid(column=50, row=20, columnspan=4, rowspan=2)

C4_on_off.grid(column=6, row=40, columnspan=4, rowspan=2)
C4S_on_off.grid(column=10, row=38, rowspan=3)
D4_on_off.grid(column=14, row=40, columnspan=4, rowspan=2)
D4S_on_off.grid(column=18, row=38, rowspan=3)
E4_on_off.grid(column=22, row=40, columnspan=4, rowspan=2)
F4_on_off.grid(column=26, row=40, columnspan=4, rowspan=2)
F4S_on_off.grid(column=30, row=38, rowspan=3)
G4_on_off.grid(column=34, row=40, columnspan=4, rowspan=2)
G4S_on_off.grid(column=38, row=38, rowspan=3)
A5_on_off.grid(column=42, row=40, columnspan=4, rowspan=2)
A5S_on_off.grid(column=46, row=38, rowspan=3)
B5_on_off.grid(column=50, row=40, columnspan=4, rowspan=2)


# Author and spacing
space = Label(octaveFrame, text="    ", background='dark goldenrod')
space.grid(column=0, row=0)
space0 = Label(keyFrame, text=" ", background='dark goldenrod')
space0.grid(column=0, row=1, columnspan=1)
space1 = Label(keyFrame, text=" ", background='dark goldenrod')
space1.grid(column=2, row=6, columnspan=1)
space2 = Label(keyFrame, text=" ", background='dark goldenrod')
space2.grid(column=2, row=7, columnspan=1)

space4 = Label(keyFrame, text=" ", background='dark goldenrod')
space4.grid(column=2, row=9, columnspan=1)

space7 = Label(keyFrame, text=" ", background='dark goldenrod')
space7.grid(column=2, row=21, columnspan=1)
space8 = Label(keyFrame, text=" ", background='dark goldenrod')
space8.grid(column=2, row=22, columnspan=1)

space18 = Label(keyFrame, text=" ", background='dark goldenrod')
space18.grid(column=2, row=41, columnspan=1)

space21 = Label(keyFrame, text="D Walker (bygonebytes.co.uk) 2019", background='dark goldenrod', foreground='white')
space21.grid(column=2, row=50, columnspan=52)

space22 = Label(utilsFrame, text=" ", background='dark goldenrod', width=8)
space22.grid(column=4, row=6)
space23 = Label(utilsFrame, text=" ", background='dark goldenrod')
space23.grid(column=2, row=30, columnspan=1)

#Define utils frame
textFrame=Frame(f3, style='keyFrame.TFrame')
textFrame.grid(row=30, column=6)
space23 = Label(textFrame, text=" ", width=8, background='dark goldenrod')
space23.grid(column=4, row=0)
space24 = Label(textFrame, text="MIDIMUSO MODE CHANGE", font=("Helvetica", 16), background='dark goldenrod', foreground='white')
space24.grid(column=6, row=1)


raise_frame(f1)
root.update_idletasks()
root.mainloop()

